/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2022 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).ASTY=e()}}(function(){return function(){return function e(t,n,r){function o(a,u){if(!n[a]){if(!t[a]){var f="function"==typeof _dereq_&&_dereq_;if(!u&&f)return f(a,!0);if(i)return i(a,!0);var c=new Error("Cannot find module '"+a+"'");throw c.code="MODULE_NOT_FOUND",c}var l=n[a]={exports:{}};t[a][0].call(l.exports,function(e){return o(t[a][1][e]||e)},l,l.exports,e,t,n,r)}return n[a].exports}for(var i="function"==typeof _dereq_&&_dereq_,a=0;a<r.length;a++)o(r[a]);return o}}()({1:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function o(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var i=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&o(e.prototype,t),n&&o(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"init",value:function(e,t,n,o){if(arguments.length<2)throw new Error("init: invalid number of arguments");if(this.ctx=e,this.ASTy=!0,this.T=t,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"===r(n))for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&this.set(i,n[i]);return"object"===r(o)&&o instanceof Array&&this.add(o),this}},{key:"create",value:function(e,t,n){return this.ctx.create(e,t,n)}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,t,n){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=t||0,this.L.O=n||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){for(var e=this,t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];if(1===n.length&&"object"===r(n[0]))Object.keys(n[0]).forEach(function(t){void 0!==n[0][t]?e.A[t]=n[0][t]:delete e.A[t]});else{if(2!==n.length)throw new Error("set: invalid number of arguments");void 0!==n[1]?this.A[n[0]]=n[1]:delete this.A[n[0]]}return this}},{key:"unset",value:function(){for(var e=this,t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];if(1===n.length&&"object"===r(n[0])&&n[0]instanceof Array)n[0].forEach(function(t){delete e.A[t]});else{if(1!==n.length)throw new Error("unset: invalid number of arguments");delete this.A[n[0]]}return this}},{key:"get",value:function(){for(var e=this,t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];if(1!==n.length)throw new Error("get: invalid number of arguments");if("object"===r(n[0])&&n[0]instanceof Array)return n[0].map(function(t){if("string"!=typeof t)throw new Error("get: invalid key argument");return e.A[t]});var i=n[0];if("string"!=typeof i)throw new Error("get: invalid key argument");return this.A[i]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"nth",value:function(){if(null===this.P)return 1;var e=this.P.C.indexOf(this);if(e<0)throw new Error("nth: internal error -- node not in childs of its parent");return e}},{key:"ins",value:function(e){for(var t=this,n=arguments.length,o=new Array(n>1?n-1:0),i=1;i<n;i++)o[i-1]=arguments[i];if(0===o.length)throw new Error("ins: invalid number of arguments");if(e<0&&(e=this.C.length+1-e),!(e>=0&&e<=this.C.length))throw new Error("ins: invalid position");var a=function(n){if(!t.ctx.isA(n))throw new Error("ins: invalid AST node argument");t.C.splice(e++,0,n),n.P=t};return o.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){a(e)}):null!==e&&a(e)}),this}},{key:"add",value:function(){for(var e=this,t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];if(0===n.length)throw new Error("add: invalid number of arguments");var i=function(t){if(!e.ctx.isA(t))throw new Error("add: invalid AST node argument");e.C.push(t),t.P=e};return n.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){i(e)}):null!==e&&i(e)}),this}},{key:"del",value:function(){for(var e=this,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];if(0===n.length)throw new Error("del: invalid number of arguments");return n.forEach(function(t){if(!e.ctx.isA(t))throw new Error("del: invalid AST node argument");for(var n=!1,r=0;r<e.C.length;r++)if(e.C[r]===t){e.C.splice(r,1),t.P=null,n=!0;break}if(!n)throw new Error("del: AST node not found in childs")}),this}},{key:"childs",value:function(){if(arguments.length>2)throw new Error("childs: invalid number of arguments");if(2===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0])&&"number"==typeof(arguments.length<=1?void 0:arguments[1]))return this.C.slice(arguments.length<=0?void 0:arguments[0],arguments.length<=1?void 0:arguments[1]);if(1===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0]))return this.C.slice(arguments.length<=0?void 0:arguments[0]);if(0===arguments.length)return this.C;throw new Error("childs: invalid type of arguments")}},{key:"child",value:function(e){if("number"!=typeof e)throw new Error("child: invalid argument");return e<this.C.length?this.C[e]:null}},{key:"parent",value:function(){return this.P}},{key:"serialize",value:function(){return this.ctx.__serialize(this)}}]),e}();n.default=i},{}],2:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function o(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var i={mid:{unicode:String.fromCharCode(9500),ascii:"+"},last:{unicode:String.fromCharCode(9492),ascii:"+"},down:{unicode:String.fromCharCode(9474),ascii:"|"},left:{unicode:String.fromCharCode(9472),ascii:"-"}},a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&o(e.prototype,t),n&&o(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"dump",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1/0,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,t){return t},n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o="",a=this;return this.walk(function(u,f){if(!(f>e)){if(f>0){var c=function(e){var t=0,n=0;return null!==e.P&&(t=e.P.C.indexOf(e),n=e.P.C.length-1),{nth:t,max:n}},l=c(u),s=l.nth,h=l.max,y=" ";y=n?"".concat(i.left.unicode).concat(i.left.unicode).concat(y):"".concat(i.left.ascii).concat(i.left.ascii).concat(y),y=s<h?"".concat(n?i.mid.unicode:i.mid.ascii).concat(y):"".concat(n?i.last.unicode:i.last.ascii).concat(y);for(var d=u.P;null!==d&&d!==a;d=d.P)if(null!==d.P){var p=c(d);y=p.nth<p.max?"".concat(n?i.down.unicode:i.down.ascii,"   ").concat(y):"    ".concat(y)}o+=t("tree",y)}o+=t("type",u.T)+" ";var v=Object.keys(u.A).filter(function(e){return!e.match(/^__/)});if(v.length>0){o+=t("parenthesis","(");var b=!0;v.forEach(function(e){b?b=!1:o+=t("comma",",")+" ",o+=t("key",e)+t("colon",":")+" ";var n=u.A[e];switch(r(n)){case"boolean":case"number":o+=t("value",n.toString());break;case"string":var i=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};o+=t("value",'"'+n.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+i(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+i(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+i(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+i(e)})+'"');break;case"object":n instanceof RegExp?o+=t("value","/"+n.source+"/"):o+=t("value",JSON.stringify(n));break;default:o+=t("value",JSON.stringify(n))}}),o+=t("parenthesis",")")+" "}o+=t("position",t("bracket","[")+t("line",u.L.L)+t("slash",",")+t("column",u.L.C)+t("bracket","]")),o+="\n"}},"downward"),o}}]),e}();n.default=a},{}],3:[function(e,t,n){"use strict";function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var o=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&r(e.prototype,t),n&&r(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"merge",value:function(e){var t=this,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(null===e)return this;if(!this.ctx.isA(e))throw new Error("merge: invalid AST node argument");if(n){var o=e.pos();this.pos(o.line,o.column,o.offset)}e.attrs().forEach(function(n){var o=void 0!==r[n]?r[n]:n;null!==o&&t.set(o,e.get(n))}),e.childs().forEach(function(n){e.del(n),t.add(n)});var i=e.parent();return null!==i&&i.del(e),this}}]),e}();n.default=o},{}],4:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function o(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var i=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&o(e.prototype,t),n&&o(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,null,[{key:"serialize",value:function(e,t){if(!e.isA(t))throw new Error("serialize: not an ASTy node");return JSON.stringify({ASTy:function e(t){var n={T:t.T,L:{L:t.L.L,C:t.L.C,O:t.L.O}},o=Object.keys(t.A);return o.length>0&&(n.A={},o.forEach(function(e){var o=t.A[e];switch(r(o)){case"boolean":case"number":case"string":n.A[e]=o;break;default:n.A[e]=JSON.parse(JSON.stringify(o))}})),t.C.length>0&&(n.C=t.C.map(function(t){return e(t)})),n}(t)})}},{key:"unserialize",value:function(e,t){var n=JSON.parse(t);if("object"!==r(n)||"object"!==r(n.ASTy))throw new Error("unserialize: not an ASTy JSON export");return function t(n){var o=e.create(n.T);return o.pos(n.L.L,n.L.C,n.L.O),"object"===r(n.A)&&Object.keys(n.A).forEach(function(e){var t=n.A[e];switch(r(t)){case"boolean":case"number":case"string":o.set(e,t);break;default:o.set(e,JSON.parse(JSON.stringify(t)))}}),"object"===r(n.C)&&n.C instanceof Array&&o.add(n.C.map(function(e){return t(e)})),o}(n.ASTy)}}]),e}();n.default=i},{}],5:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var r={major:1,minor:8,micro:16,date:20220408};n.default=r},{}],6:[function(e,t,n){"use strict";function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var o=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&r(e.prototype,t),n&&r(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"walk",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"downward";return function n(r,o,i){"downward"!==t&&"both"!==t||e(r,o,i,"downward"),r.C.forEach(function(e){n(e,o+1,r)}),"upward"!==t&&"both"!==t||e(r,o,i,"upward")}(this,0,null),this}}]),e}();n.default=o},{}],7:[function(e,t,n){"use strict";var r=c(e("./asty-base.js")),o=c(e("./asty-merge.js")),i=c(e("./asty-walk.js")),a=c(e("./asty-dump.js")),u=c(e("./asty-serialize.js")),f=c(e("./asty-version.js"));function c(e){return e&&e.__esModule?e:{default:e}}function l(e){return(l="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function s(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function h(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function y(e,t,n){return t&&h(e.prototype,t),n&&h(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}var d=function(){function e(){var t=this;return s(this,e),this.ASTYNode=y(function e(){s(this,e)}),[[r.default,"init","create","type","pos","set","unset","get","attrs","nth","ins","add","del","childs","child","parent","serialize"],[o.default,"merge"],[i.default,"walk"],[a.default,"dump"]].forEach(function(e){var n=e[0].prototype;e.slice(1).forEach(function(e){t.ASTYNode.prototype[e]=n[e]})}),this}return y(e,[{key:"version",value:function(){return f.default}},{key:"extend",value:function(e){for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this.ASTYNode.prototype[t]=e[t]);return this}},{key:"create",value:function(e,t,n){return(new this.ASTYNode).init(this,e,t,n)}},{key:"isA",value:function(e){return"object"===l(e)&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&!0===e.ASTy}},{key:"__serialize",value:function(t){return e.serialize(t)}}],[{key:"serialize",value:function(e){return u.default.serialize(e.ctx,e)}},{key:"unserialize",value:function(e){return u.default.unserialize(new this,e)}}]),e}();t.exports=d},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],2:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).CacheLRU=e()}}(function(){return function(){return function e(t,i,n){function r(u,s){if(!i[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var h=new Error("Cannot find module '"+u+"'");throw h.code="MODULE_NOT_FOUND",h}var a=i[u]={exports:{}};t[u][0].call(a.exports,function(e){return r(t[u][1][e]||e)},a,a.exports,e,t,i,n)}return i[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<n.length;u++)r(n[u]);return r}}()({1:[function(e,t,i){"use strict";function n(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var r=function(){function e(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return function(e,t,i){t&&n(e.prototype,t),i&&n(e,i)}(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var i=0,n=this._MRU.older;n!==this._LRU;)e.call(t,n.val,n.key,i++),n=n.older;return t}},{key:"has",value:function(e){var t=this._index[e];return void 0!==t&&t.expires>=Date.now()}},{key:"peek",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return t.val;this.del(t.key)}}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return this._promote(t),t.val;this.del(t.key)}}},{key:"set",value:function(e,t,i){arguments.length<3&&(i=1/0),i+=Date.now();var n=this._index[e];if(void 0===n)n={older:null,newer:null,key:e,val:t,expires:i},this._index[e]=n,this._attach(n),this._cur++,this._purge();else{var r=n.val;n.val=t,this._promote(n),this._dispose.call(void 0,n.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();t.exports=r},{}]},{},[1])(1)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],3:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e,n,r){"object"==typeof module&&"object"==typeof module.exports?module.exports=r():"function"==typeof define&&void 0!==define.amd?define("PEGUtil",function(){return r()}):e.PEGUtil=r()}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,0,function(){var e={makeAST:function(e,n){return function(){return n.util.__makeAST.call(null,e().start.line,e().start.column,e().start.offset,arguments)}},makeUnroll:function(e,n){return function(r,t,o){if("object"!=typeof t||!(t instanceof Array))throw new n.util.__SyntaxError("unroll: invalid list argument for unrolling",typeof t,"Array",e());if(void 0!==o){"number"==typeof o&&(o=[o]);var l=[];null!==r&&l.push(r);for(var a=0;a<t.length;a++)for(var i=0;i<o.length;i++)l.push(t[a][o[i]]);return l}return null!==r&&t.unshift(r),t}}},n=function(e,n){var r=e.length,t=n-20;t<0&&(t=0);var o=n+20;o>r&&(o=r);var l=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},a=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+l(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+l(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+l(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+l(e)})};return{prolog:a(e,t,n-t),token:a(e,n,1),epilog:a(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if(void 0!==o&&"object"!=typeof o)throw new Error("invalid options (not an object)");void 0===o&&(o={});var l={ast:null,error:null};try{var a;a="function"==typeof o.makeAST?o.makeAST:function(e,n){return{line:e().start.line,column:e().start.column,offset:e().start.offset,args:n}},o.util={makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:a,__SyntaxError:r.SyntaxError},l.ast=r.parse(t,o),l.error=null}catch(e){if(l.ast=null,e instanceof r.SyntaxError){var i=function(e,n){return void 0!==e?e:n};l.error={line:i(e.location.start.line,0),column:i(e.location.start.column,0),message:e.message,found:i(e.found,""),expected:i(e.expected,""),location:n(t,i(e.location.start.offset,0))}}else l.error={line:0,column:0,message:e.message,found:"",expected:"",location:n("",0)}}return l},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",l=0;l<t.length+r.prolog.length;l++)o+="-";return t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n")},e});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],4:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function _createClass(e,t,n){return t&&_defineProperties(e.prototype,t),n&&_defineProperties(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterASTY=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();exports.default=ASTQAdapterASTY;
},{}],5:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var n=t[o];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterCheerio=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&!("object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&e instanceof Node)&&"string"==typeof e.tagName&&""!==e.tagName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.tagName||"#".concat(e.type||"unknown")}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attribs)&&(t=t.concat(Object.keys(e.attribs))),t}},{key:"getNodeAttrValue",value:function(e,t){var o;return"value"===t?o=e.nodeValue:"object"===_typeof(e.attribs)&&(o=e.attribs[t]),o}}]),e}();exports.default=ASTQAdapterCheerio;
},{}],6:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterGraphQL=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.kind&&""!==e.kind}},{key:"getParentNode",value:function(e,t){throw new Error("GraphQL AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var o=this,r=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&o.taste(e[t])?r.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){o.taste(e)&&r.push(e)})};if("*"===t)for(var a in e)n(e,a);else void 0!==e[t]&&n(e,t);return r}},{key:"getNodeType",value:function(e){return e.kind}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&"object"!==_typeof(e[o])&&"kind"!==o&&"loc"!==o&&t.push(o);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"kind"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports.default=ASTQAdapterGraphQL;
},{}],7:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterJSON=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e}},{key:"getParentNode",value:function(e,t){throw new Error("JSON does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var o=this,r=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&o.taste(e[t])?r.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){o.taste(e)&&r.push(e)})};if("*"===t)for(var a in e)n(e,a);else void 0!==e[t]&&n(e,t);return r}},{key:"getNodeType",value:function(e){return null===e?"Null":e instanceof Boolean?"Boolean":e instanceof Number?"Number":e instanceof String?"String":"object"===_typeof(e)?e instanceof Array?"Array":"function"==typeof e.constructor&&"string"==typeof e.constructor.name?e.constructor.name:"Object":"Unknown"}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&"object"!==_typeof(e[o])&&t.push(o);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();exports.default=ASTQAdapterJSON;
},{}],8:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterMozAST=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if(void 0!==e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var o=this,r=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&o.taste(e[t])?r.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){o.taste(e)&&r.push(e)})};if("*"===t)for(var a in e)n(e,a);else void 0!==e[t]&&n(e,t);return r}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&"object"!==_typeof(e[o])&&"type"!==o&&"loc"!==o&&t.push(o);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports.default=ASTQAdapterMozAST;
},{}],9:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function _createClass(e,t,n){return t&&_defineProperties(e.prototype,t),n&&_defineProperties(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterParse5=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&!("object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&e instanceof Node)&&"string"==typeof e.nodeName&&""!==e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attrs)&&e.attrs instanceof Array&&(t=t.concat(e.attrs.map(function(e){return e.name}))),t}},{key:"getNodeAttrValue",value:function(e,t){var n;if("value"===t)n=e.value;else if("object"===_typeof(e.attrs)&&e.attrs instanceof Array){var o=e.attrs.filter(function(e){return e.name===t}).map(function(e){return e.value});1===o.length&&(n=o[0])}return n}}]),e}();exports.default=ASTQAdapterParse5;
},{}],10:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterUniST=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e){if("object"===_typeof(e.parent)&&null!==e.parent)return e.parent;throw new Error("Your UniST AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.children)&&e.children instanceof Array?e.children:[]}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"type"!==r&&"data"!==r&&"position"!==r&&"children"!==r&&"object"!==_typeof(e[r])&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"type"!==t&&"data"!==t&&"position"!==t&&"children"!==t&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();exports.default=ASTQAdapterUniST;
},{}],11:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var n=t[o];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterXMLDOM=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&null!==e&&e instanceof Node&&"object"===_typeof(e)&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&null!==e.childNodes&&e.hasChildNodes()?Array.prototype.slice.call(e.childNodes,0):[]}},{key:"getNodeType",value:function(e){return"string"==typeof e.nodeName?e.nodeName:"unknown"}},{key:"getNodeAttrNames",value:function(e){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName}):[]}},{key:"getNodeAttrValue",value:function(e,t){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?e.getAttribute(t):void 0}}]),e}();exports.default=ASTQAdapterXMLDOM;
},{}],12:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapter=function(){function e(){return _classCallCheck(this,e),this._adapters=[],this}return _createClass(e,[{key:"register",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this._adapters.unshift({adapter:e,force:t}),this}},{key:"unregister",value:function(e){if(void 0===e)this._adapters=[];else{for(var t=[],r=0;r<this._adapters.length;r++)this._adapters[r].adapter!==e&&t.push(this._adapters[r]);this._adapters=t}return this}},{key:"select",value:function(e){for(var t=0;t<this._adapters.length;t++)if(this._adapters[t].force||this._adapters[t].adapter.taste(e))return this._adapters[t].adapter}}]),e}();exports.default=ASTQAdapter;
},{}],13:[function(_dereq_,module,exports){
"use strict";function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _pos=function(t,n){var e=t.getParentNode(n,"*");if(null===e)return 1;for(var r=t.getChildNodes(e,"*"),o=0;o<r.length;o++)if(r[o]===n)return o+1;throw new Error("cannot find myself")},parents=function(t,n){for(var e=[];null!==(n=t.getParentNode(n,"*"));)e.push(n);return e},stdfuncs={type:function(t,n){return t.getNodeType(n)},attrs:function(t,n,e){return void 0===e&&(e=" "),e+t.getNodeAttrNames(n).join(e)+e},depth:function(t,n){for(var e=1,r=n;null!==(r=t.getParentNode(r,"*"));)e++;return e},pos:function(t,n){return _pos(t,n)},nth:function(t,n,e){e=parseInt(e,10);var r=t.getParentNode(n,"*");if(null!==r){var o=t.getChildNodes(r,"*");e<0&&(e=o.length-(e+1));for(var u=0;u<o.length;u++)if(o[u]===n)return u+1===e;return!1}return 1===e},first:function(t,n){return stdfuncs.nth(t,n,1)},last:function(t,n){return stdfuncs.nth(t,n,-1)},count:function(t,n,e){return"object"===_typeof(e)&&e instanceof Array?e.length:"object"===_typeof(e)?Object.keys(e).length:"string"==typeof e?e.length:String(e).length},below:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "below" (node expected)');for(var r=n;null!==(r=t.getParentNode(r,"*"));)if(r===e)return!0;return!1},follows:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "follows" (node expected)');if(n===e)return!1;var r,o=[n].concat(parents(t,n)).reverse(),u=[e].concat(parents(t,e)).reverse(),f=Math.min(o.length,u.length);for(r=0;r<f&&o[r]===u[r];r++);if(0===r)throw new Error("internal error: root nodes have to be same same");return r===f?u.length<o.length:_pos(t,o[r])>_pos(t,u[r])},in:function(t,n,e){if(!("object"===_typeof(e)&&e instanceof Array))throw new Error('invalid argument to function "in" (array expected)');for(var r=0;r<e.length;r++)if(e[r]===n)return!0;return!1},substr:function(t,n,e,r,o){return String(e).substr(r,o)},index:function(t,n,e,r,o){return String(e).indexOf(r,o)},trim:function(t,n,e){return String(e).trim()},lc:function(t,n,e){return String(e).toLowerCase()},uc:function(t,n,e){return String(e).toUpperCase()}},_default=stdfuncs;exports.default=_default;
},{}],14:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function _createClass(e,t,n){return t&&_defineProperties(e.prototype,t),n&&_defineProperties(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQFuncs=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,t){this._funcs[e]=t}},{key:"run",value:function(e,t){var n=this._funcs[e];if("function"!=typeof n)throw new Error('invalid function "'+e+'"');return n.apply(null,t)}}]),e}();exports.default=ASTQFuncs;
},{}],15:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js")),_astqQueryTrace=_interopRequireDefault(_dereq_("./astq-query-trace.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e})(e,t)}function _createSuper(e){var t=_isNativeReflectConstruct();return function(){var r,a=_getPrototypeOf(e);if(t){var i=_getPrototypeOf(this).constructor;r=Reflect.construct(a,arguments,i)}else r=a.apply(this,arguments);return _possibleConstructorReturn(this,r)}}function _possibleConstructorReturn(e,t){if(t&&("object"===_typeof(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(e)}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _isNativeReflectConstruct(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],function(){})),!0}catch(e){return!1}}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}var ASTQQueryExec=function(e){_inherits(r,_astqQueryTrace["default"]);var t=_createSuper(r);function r(e,a,i,n){var c;return _classCallCheck(this,r),(c=t.call(this)).adapter=e,c.params=a,c.funcs=i,c.trace=n,c}return _createClass(r,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t],i=[],n=!1;return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t,e.get("isResult")&&(n=!0,i=i.concat(a))}),this.traceEnd(e,t,a),n?i:a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,n=null,c=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(n=a[s++]),s<a.length&&"Filter"===a[s].type()&&(c=a[s++]),null===n)throw new Error("no matching part in query step");var l=[],u=n.get("id"),o=function(e){var t=r.adapter.getNodeType(e);if("*"===u||u===t){var a=!0;null!==c&&(r.execFilter(c,e)||(a=!1)),a&&l.push(e)}};if(null!==i){var f=i.get("op"),h=i.get("type");if("/"===f)this.adapter.getChildNodes(t,h).forEach(function(e){return o(e)});else if("//"===f){this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){o(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("./"===f)o(t),this.adapter.getChildNodes(t,h).forEach(function(e){return o(e)});else if(".//"===f){o(t);this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){o(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("-/"===f){var d=this.adapter.getParentNode(t,"*");if(null!==d){for(var p=this.adapter.getChildNodes(d,h),x=null,g=0;g<p.length&&p[g]!==t;g++)x=p[g];null!==x&&o(x)}}else if("-//"===f){var y=this.adapter.getParentNode(t,"*");if(null!==y){for(var v=this.adapter.getChildNodes(y,h),E=0;E<v.length&&v[E]!==t;E++);for(E--;E>=0;E--)o(v[E])}}else if("+/"===f){var b=this.adapter.getParentNode(t,"*");if(null!==b){var _,m=this.adapter.getChildNodes(b,h);for(_=0;_<m.length&&m[_]!==t;_++);_<m.length&&o(m[++_])}}else if("+//"===f){var k=this.adapter.getParentNode(t,"*");if(null!==k){var q,U=this.adapter.getChildNodes(k,h);for(q=0;q<U.length&&U[q]!==t;q++);if(q<U.length)for(q++;q<U.length;q++)o(U[q])}}else if("~/"===f){var P=this.adapter.getParentNode(t,"*");if(null!==P){var C,N=this.adapter.getChildNodes(P,h);for(C=0;C<N.length&&N[C]!==t;C++);C>0&&o(N[C-1]),C<N.length-1&&o(N[C+1])}}else if("~//"===f){var B=this.adapter.getParentNode(t,"*");if(null!==B)for(var w=this.adapter.getChildNodes(B,h),O=0;O<w.length;O++)w[O]!==t&&o(w[O])}else if("../"===f){var R=this.adapter.getParentNode(t,h);null!==R&&o(R)}else if("..//"===f)for(var L=t;;){var S=this.adapter.getParentNode(L,h);if(null===S)break;o(S),L=S}else if("<//"===f){for(var j={sentinel:t,take:!0};;){var T=this.adapter.getParentNode(t,"*");if(null===T)break;t=T}t!==j.sentinel&&(o(t),this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){t===j.sentinel&&(j.take=!1),j.take&&o(t),j.take&&r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})),l=l.reverse()}else if(">//"===f){for(var A={sentinel:t,take:!1};;){var Q=this.adapter.getParentNode(t,"*");if(null===Q)break;t=Q}this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){A.take&&o(t),t===A.sentinel&&(A.take=!0),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}}else o(t);return this.traceEnd(e,t,l),l}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtil.default.truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtil.default.truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtil.default.truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))&&(r=r&&_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)));break;case"||":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))||(r=r||_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r,a=_astqUtil.default.coerce(this.execExpr(e.childs()[0],t),"number"),i=_astqUtil.default.coerce(this.execExpr(e.childs()[1],t),"number");switch(e.get("op")){case"&":r=a&i;break;case"|":r=a|i;break;case"<<":r=a<<i;break;case">>":r=a>>i}return this.traceEnd(e,t,r),r}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"==":r=a===i;break;case"!=":r=a!==i;break;case"<=":r=_astqUtil.default.coerce(a,"number")<=_astqUtil.default.coerce(i,"number");break;case">=":r=_astqUtil.default.coerce(a,"number")>=_astqUtil.default.coerce(i,"number");break;case"<":r=_astqUtil.default.coerce(a,"number")<_astqUtil.default.coerce(i,"number");break;case">":r=_astqUtil.default.coerce(a,"number")>_astqUtil.default.coerce(i,"number");break;case"=~":r=null!==_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"));break;case"!~":r=null===_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"))}return this.traceEnd(e,t,r),r}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"+":r="string"==typeof a?a+_astqUtil.default.coerce(i,"string"):_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"-":r=_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"*":r=_astqUtil.default.coerce(a,"number")*_astqUtil.default.coerce(i,"number");break;case"/":r=_astqUtil.default.coerce(a,"number")/_astqUtil.default.coerce(i,"number");break;case"%":r=_astqUtil.default.coerce(a,"number")%_astqUtil.default.coerce(i,"number");break;case"**":r=Math.pow(_astqUtil.default.coerce(a,"number"),_astqUtil.default.coerce(i,"number"))}return this.traceEnd(e,t,r),r}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t);switch(e.get("op")){case"!":r=!_astqUtil.default.coerce(a,"boolean");break;case"~":r=~_astqUtil.default.coerce(a,"number")}return this.traceEnd(e,t,r),r}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var n=this.funcs.run(a,i);return this.traceEnd(e,t,n),n}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if(void 0===this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),r}();exports.default=ASTQQueryExec;
},{"./astq-query-trace.js":16,"./astq-util.js":18}],16:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}var ASTQQueryTrace=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,o=e;null!==(o=o.parent());)r++;var a=_astqUtil.default.pad("",4*r);for(r=0,o=t;null!==(o=this.adapter.getParentNode(o,"*"));)r++;return{prefix1:a,prefix2:_astqUtil.default.pad("",4*r)}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),o=r.prefix1,a=r.prefix2;console.log("ASTQ: execute: | "+_astqUtil.default.pad(o+e.type()+" (",-60)+" | "+a+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var o=this;if(this.trace){var a,n=this.prefixOf(e,t),i=n.prefix1,f=n.prefix2;void 0===r?a="undefined":"object"===_typeof(r)&&r instanceof Array?(a="[",r.forEach(function(e){a+="node("+o.adapter.getNodeType(e)+"),"}),a=a.replace(/,$/,"")+"]"):a=_typeof(r)+"("+r+")",a.length>60&&(a=a.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtil.default.pad(i+"): "+a,-60)+" | "+f+this.adapter.getNodeType(t))}}}]),e}();exports.default=ASTQQueryTrace;
},{"./astq-util.js":18}],17:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _asty=_interopRequireDefault(_dereq_("asty")),_pegjsUtil=_interopRequireDefault(_dereq_("pegjs-util")),_astqQueryExec=_interopRequireDefault(_dereq_("./astq-query-exec.js"));function _interopRequireDefault(t){return t&&t.__esModule?t:{default:t}}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}function _createClass(t,e,r){return e&&_defineProperties(t.prototype,e),r&&_defineProperties(t,r),Object.defineProperty(t,"prototype",{writable:!1}),t}var ASTQQueryParse=function(){function t(e,r,n,u){this.message=e,this.expected=r,this.found=n,this.location=u,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}return function(t,e){function r(){this.constructor=t}r.prototype=e.prototype,t.prototype=new r}(t,Error),t.buildMessage=function(t,e){var r={literal:function(t){return'"'+u(t.text)+'"'},class:function(t){var e,r="";for(e=0;e<t.parts.length;e++)r+=t.parts[e]instanceof Array?s(t.parts[e][0])+"-"+s(t.parts[e][1]):s(t.parts[e]);return"["+(t.inverted?"^":"")+r+"]"},any:function(t){return"any character"},end:function(t){return"end of input"},other:function(t){return t.description}};function n(t){return t.charCodeAt(0).toString(16).toUpperCase()}function u(t){return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}function s(t){return t.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}return"Expected "+function(t){var e,n,u,s=new Array(t.length);for(e=0;e<t.length;e++)s[e]=(u=t[e],r[u.type](u));if(s.sort(),s.length>0){for(e=1,n=1;e<s.length;e++)s[e-1]!==s[e]&&(s[n]=s[e],n++);s.length=n}switch(s.length){case 1:return s[0];case 2:return s[0]+" or "+s[1];default:return s.slice(0,-1).join(", ")+", or "+s[s.length-1]}}(t)+" but "+function(t){return t?'"'+u(t)+'"':"end of input"}(e)+" found."},{SyntaxError:t,parse:function(e,r){r=void 0!==r?r:{};var n,u={},s={query:Dn},a=Dn,o=function(t){return t},i=",",c=Nn(",",!1),l=function(t,e){return pu("Query").add(du(t,e,3))},f=function(t,e){return pu("Path").add(du(t,e,1))},h="!",A=Nn("!",!1),d=function(t,e,r,n){return pu("Step").add(t,e,n).set(null!==r?{isResult:!0}:{})},p=Mn("axis"),x="//",b=Nn("//",!1),g="/",v=Nn("/",!1),P="-//",C=Nn("-//",!1),y="-/",m=Nn("-/",!1),_="+//",w=Nn("+//",!1),S="+/",q=Nn("+/",!1),Q="~//",E=Nn("~//",!1),R="~/",T=Nn("~/",!1),F="..//",L=Nn("..//",!1),k="../",N=Nn("../",!1),j=".//",M=Nn(".//",!1),I="./",U=Nn("./",!1),V="<//",z=Nn("<//",!1),D=">//",O=Nn(">//",!1),Z=function(t,e){return pu("Axis").set({op:t,type:null!==e?e:"*"})},B=":",$=Nn(":",!1),G=function(t){return t.get("id")},H=function(t){return t.get("value")},J=function(t){return pu("Match").merge(t)},K=function(t){return pu("Match").set({id:t.get("value")})},W="*",X=Nn("*",!1),Y=function(){return pu("Match").set({id:"*"})},tt="[",et=Nn("[",!1),rt="]",nt=Nn("]",!1),ut=function(t){return pu("Filter").add(t)},st="?:",at=Nn("?:",!1),ot=function(t,e){return pu("ConditionalBinary").add(t,e)},it="?",ct=Nn("?",!1),lt=function(t,e,r){return pu("ConditionalTernary").add(t,e,r)},ft="||",ht=Nn("||",!1),At=function(t,e,r){return pu("Logical").set({op:e}).add(t,r)},dt="&&",pt=Nn("&&",!1),xt="|",bt=Nn("|",!1),gt=function(t,e,r){return pu("Bitwise").set({op:e}).add(t,r)},vt="^",Pt=Nn("^",!1),Ct="&",yt=Nn("&",!1),mt="==",_t=Nn("==",!1),wt="!=",St=Nn("!=",!1),qt="<=",Qt=Nn("<=",!1),Et=">=",Rt=Nn(">=",!1),Tt="<",Ft=Nn("<",!1),Lt=">",kt=Nn(">",!1),Nt="=~",jt=Nn("=~",!1),Mt="!~",It=Nn("!~",!1),Ut=function(t,e,r){return pu("Relational").set({op:e}).add(t,r)},Vt="<<",zt=Nn("<<",!1),Dt=">>",Ot=Nn(">>",!1),Zt="+",Bt=Nn("+",!1),$t="-",Gt=Nn("-",!1),Ht=function(t,e,r){return pu("Arithmetical").set({op:e}).add(t,r)},Jt="**",Kt=Nn("**",!1),Wt="%",Xt=Nn("%",!1),Yt="~",te=Nn("~",!1),ee=function(t,e){return pu("Unary").set({op:t}).add(e)},re="(",ne=Nn("(",!1),ue=")",se=Nn(")",!1),ae=function(t,e){return pu("FuncCall").merge(t).add(e)},oe=function(t,e){return du(t,e,3)},ie=Mn("node attribute"),ce="@",le=Nn("@",!1),fe=function(t){return pu("Attribute").merge(t)},he=function(t){return pu("Attribute").set({id:t.get("value")})},Ae=Mn("query parameter reference"),de="{",pe=Nn("{",!1),xe="}",be=Nn("}",!1),ge=function(t){return pu("Param").merge(t)},ve=function(t){return t},Pe=Mn("identifier"),Ce=/^[a-zA-Z_]/,ye=jn([["a","z"],["A","Z"],"_"],!1,!1),me=/^[a-zA-Z0-9_\-]/,_e=jn([["a","z"],["A","Z"],["0","9"],"_","-"],!1,!1),we=function(t){return pu("Identifier").set({id:t})},Se=Mn("quoted string literal"),qe='"',Qe=Nn('"',!1),Ee=/^[^"]/,Re=jn(['"'],!0,!1),Te=function(t){return pu("LiteralString").set({value:t.join("")})},Fe="'",Le=Nn("'",!1),ke=/^[^']/,Ne=jn(["'"],!0,!1),je=Mn("escaped double-quoted-string character"),Me="\\\\",Ie=Nn("\\\\",!1),Ue=function(){return"\\"},Ve='\\"',ze=Nn('\\"',!1),De=function(){return'"'},Oe="\\b",Ze=Nn("\\b",!1),Be=function(){return"\b"},$e="\\v",Ge=Nn("\\v",!1),He=function(){return"\v"},Je="\\f",Ke=Nn("\\f",!1),We=function(){return"\f"},Xe="\\t",Ye=Nn("\\t",!1),tr=function(){return"\t"},er="\\r",rr=Nn("\\r",!1),nr=function(){return"\r"},ur="\\n",sr=Nn("\\n",!1),ar=function(){return"\n"},or="\\e",ir=Nn("\\e",!1),cr=function(){return""},lr="\\x",fr=Nn("\\x",!1),hr=/^[0-9a-fA-F]/,Ar=jn([["0","9"],["a","f"],["A","F"]],!1,!1),dr=function(t){return String.fromCharCode(parseInt(t,16))},pr="\\u",xr=Nn("\\u",!1),br=Mn("escaped single-quoted-string character"),gr="\\'",vr=Nn("\\'",!1),Pr=function(){return"'"},Cr=Mn("regular expression literal"),yr="`",mr=Nn("`",!1),_r="\\`",wr=Nn("\\`",!1),Sr=/^[^`]/,qr=jn(["`"],!0,!1),Qr=function(e){var r;try{r=new RegExp(e.replace(/\\`/g,"`"))}catch(e){!function(e,r){throw r=void 0!==r?r:Un(Qn,qn),function(e,r){return new t(e,null,null,r)}(e,r)}(e.message)}return pu("LiteralRegExp").set({value:r})},Er=Mn("numeric literal"),Rr=/^[+\-]/,Tr=jn(["+","-"],!1,!1),Fr="0b",Lr=Nn("0b",!1),kr=/^[01]/,Nr=jn(["0","1"],!1,!1),jr=function(t,e){return pu("LiteralNumber").set({value:parseInt(t+e,2)})},Mr="0o",Ir=Nn("0o",!1),Ur=/^[0-7]/,Vr=jn([["0","7"]],!1,!1),zr=function(t,e){return pu("LiteralNumber").set({value:parseInt(t+e,8)})},Dr="0x",Or=Nn("0x",!1),Zr=function(t,e){return pu("LiteralNumber").set({value:parseInt(t+e,16)})},Br=/^[0-9]/,$r=jn([["0","9"]],!1,!1),Gr=".",Hr=Nn(".",!1),Jr=/^[eE]/,Kr=jn(["e","E"],!1,!1),Wr=function(t){return pu("LiteralNumber").set({value:parseFloat(t)})},Xr=function(t){return pu("LiteralNumber").set({value:parseInt(t,10)})},Yr=Mn("global value"),tn="true",en=Nn("true",!1),rn=function(){return pu("LiteralValue").set({value:!0})},nn="false",un=Nn("false",!1),sn=function(){return pu("LiteralValue").set({value:!1})},an="null",on=Nn("null",!1),cn=function(){return pu("LiteralValue").set({value:null})},ln="NaN",fn=Nn("NaN",!1),hn=function(){return pu("LiteralValue").set({value:NaN})},An="undefined",dn=Nn("undefined",!1),pn=function(){return pu("LiteralValue").set({value:void 0})},xn=Mn("optional blank"),bn=Mn("multi-line comment"),gn="/*",vn=Nn("/*",!1),Pn="*/",Cn=Nn("*/",!1),yn={type:"any"},mn=Mn("any whitespaces"),_n=/^[ \t\r\n]/,wn=jn([" ","\t","\r","\n"],!1,!1),Sn=Mn("end of file"),qn=0,Qn=0,En=[{line:1,column:1}],Rn=0,Tn=[],Fn=0,Ln={};if("startRule"in r){if(!(r.startRule in s))throw new Error("Can't start parsing from rule \""+r.startRule+'".');a=s[r.startRule]}function kn(){return Un(Qn,qn)}function Nn(t,e){return{type:"literal",text:t,ignoreCase:e}}function jn(t,e,r){return{type:"class",parts:t,inverted:e,ignoreCase:r}}function Mn(t){return{type:"other",description:t}}function In(t){var r,n=En[t];if(n)return n;for(r=t-1;!En[r];)r--;for(n={line:(n=En[r]).line,column:n.column};r<t;)10===e.charCodeAt(r)?(n.line++,n.column=1):n.column++,r++;return En[t]=n,n}function Un(t,e){var r=In(t),n=In(e);return{start:{offset:t,line:r.line,column:r.column},end:{offset:e,line:n.line,column:n.column}}}function Vn(t){qn<Rn||(qn>Rn&&(Rn=qn,Tn=[]),Tn.push(t))}function zn(e,r,n){return new t(t.buildMessage(e,r),e,r,n)}function Dn(){var t,r,n=38*qn+0,s=Ln[n];return s?(qn=s.nextPos,s.result):(t=qn,fu()!==u&&(r=function(){var t,r,n,s,a,o,f,h,A=38*qn+1,d=Ln[A];if(d)return qn=d.nextPos,d.result;if(t=qn,(r=On())!==u){for(n=[],s=qn,(a=fu())!==u?(44===e.charCodeAt(qn)?(o=i,qn++):(o=u,0===Fn&&Vn(c)),o!==u&&(f=fu())!==u&&(h=On())!==u?s=a=[a,o,f,h]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,(a=fu())!==u?(44===e.charCodeAt(qn)?(o=i,qn++):(o=u,0===Fn&&Vn(c)),o!==u&&(f=fu())!==u&&(h=On())!==u?s=a=[a,o,f,h]:(qn=s,s=u)):(qn=s,s=u);n!==u?(Qn=t,r=l(r,n),t=r):(qn=t,t=u)}else qn=t,t=u;return Ln[A]={nextPos:qn,result:t},t}())!==u&&fu()!==u&&function(){var t,r,n=38*qn+37,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,Fn++,e.length>qn?(r=e.charAt(qn),qn++):(r=u,0===Fn&&Vn(yn)),Fn--,r===u?t=void 0:(qn=t,t=u),Fn--,t===u&&(r=u,0===Fn&&Vn(Sn)),Ln[n]={nextPos:qn,result:t},t)}()!==u?(Qn=t,t=o(r)):(qn=t,t=u),Ln[n]={nextPos:qn,result:t},t)}function On(){var t,r,n,s,a,o,i=38*qn+2,c=Ln[i];if(c)return qn=c.nextPos,c.result;if(t=qn,(r=function(){var t,r,n,s,a,o=38*qn+3,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Bn())===u&&(r=null),r!==u&&fu()!==u&&(n=$n())!==u&&fu()!==u?(33===e.charCodeAt(qn)?(s=h,qn++):(s=u,0===Fn&&Vn(A)),s===u&&(s=null),s!==u&&fu()!==u?((a=Gn())===u&&(a=null),a!==u?(Qn=t,r=d(r,n,s,a),t=r):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[o]={nextPos:qn,result:t},t)}())!==u){for(n=[],s=qn,(a=fu())!==u&&(o=Zn())!==u?s=a=[a,o]:(qn=s,s=u);s!==u;)n.push(s),s=qn,(a=fu())!==u&&(o=Zn())!==u?s=a=[a,o]:(qn=s,s=u);n!==u?(Qn=t,t=r=f(r,n)):(qn=t,t=u)}else qn=t,t=u;return Ln[i]={nextPos:qn,result:t},t}function Zn(){var t,r,n,s,a,o=38*qn+4,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Bn())!==u&&fu()!==u&&(n=$n())!==u&&fu()!==u?(33===e.charCodeAt(qn)?(s=h,qn++):(s=u,0===Fn&&Vn(A)),s===u&&(s=null),s!==u&&fu()!==u?((a=Gn())===u&&(a=null),a!==u?(Qn=t,t=r=d(r,n,s,a)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[o]={nextPos:qn,result:t},t)}function Bn(){var t,r,n,s=38*qn+5,a=Ln[s];return a?(qn=a.nextPos,a.result):(Fn++,t=qn,r=qn,e.substr(qn,2)===x?(n=x,qn+=2):(n=u,0===Fn&&Vn(b)),n===u&&(47===e.charCodeAt(qn)?(n=g,qn++):(n=u,0===Fn&&Vn(v)),n===u&&(e.substr(qn,3)===P?(n=P,qn+=3):(n=u,0===Fn&&Vn(C)),n===u&&(e.substr(qn,2)===y?(n=y,qn+=2):(n=u,0===Fn&&Vn(m)),n===u&&(e.substr(qn,3)===_?(n=_,qn+=3):(n=u,0===Fn&&Vn(w)),n===u&&(e.substr(qn,2)===S?(n=S,qn+=2):(n=u,0===Fn&&Vn(q)),n===u&&(e.substr(qn,3)===Q?(n=Q,qn+=3):(n=u,0===Fn&&Vn(E)),n===u&&(e.substr(qn,2)===R?(n=R,qn+=2):(n=u,0===Fn&&Vn(T)),n===u&&(e.substr(qn,4)===F?(n=F,qn+=4):(n=u,0===Fn&&Vn(L)),n===u&&(e.substr(qn,3)===k?(n=k,qn+=3):(n=u,0===Fn&&Vn(N)),n===u&&(e.substr(qn,3)===j?(n=j,qn+=3):(n=u,0===Fn&&Vn(M)),n===u&&(e.substr(qn,2)===I?(n=I,qn+=2):(n=u,0===Fn&&Vn(U)),n===u&&(e.substr(qn,3)===V?(n=V,qn+=3):(n=u,0===Fn&&Vn(z)),n===u&&(e.substr(qn,3)===D?(n=D,qn+=3):(n=u,0===Fn&&Vn(O))))))))))))))),(r=n!==u?e.substring(r,qn):n)!==u?((n=function(){var t,r,n,s=38*qn+6,a=Ln[s];return a?(qn=a.nextPos,a.result):(t=qn,58===e.charCodeAt(qn)?(r=B,qn++):(r=u,0===Fn&&Vn($)),r!==u&&(n=au())!==u?(Qn=t,r=G(n),t=r):(qn=t,t=u),t===u&&(t=qn,58===e.charCodeAt(qn)?(r=B,qn++):(r=u,0===Fn&&Vn($)),r!==u&&(n=ou())!==u?(Qn=t,r=H(n),t=r):(qn=t,t=u)),Ln[s]={nextPos:qn,result:t},t)}())===u&&(n=null),n!==u?(Qn=t,t=r=Z(r,n)):(qn=t,t=u)):(qn=t,t=u),Fn--,t===u&&(r=u,0===Fn&&Vn(p)),Ln[s]={nextPos:qn,result:t},t)}function $n(){var t,r,n=38*qn+7,s=Ln[n];return s?(qn=s.nextPos,s.result):(t=qn,(r=au())!==u&&(Qn=t,r=J(r)),(t=r)===u&&(t=qn,(r=ou())!==u&&(Qn=t,r=K(r)),(t=r)===u&&(t=qn,42===e.charCodeAt(qn)?(r=W,qn++):(r=u,0===Fn&&Vn(X)),r!==u&&(Qn=t,r=Y()),t=r)),Ln[n]={nextPos:qn,result:t},t)}function Gn(){var t,r,n,s,a=38*qn+8,o=Ln[a];return o?(qn=o.nextPos,o.result):(t=qn,91===e.charCodeAt(qn)?(r=tt,qn++):(r=u,0===Fn&&Vn(et)),r!==u&&fu()!==u&&(n=Hn())!==u&&fu()!==u?(93===e.charCodeAt(qn)?(s=rt,qn++):(s=u,0===Fn&&Vn(nt)),s!==u?(Qn=t,t=r=ut(n)):(qn=t,t=u)):(qn=t,t=u),Ln[a]={nextPos:qn,result:t},t)}function Hn(){var t,r,n,s,a,o,i=38*qn+9,c=Ln[i];return c?(qn=c.nextPos,c.result):(t=qn,(r=Jn())!==u&&fu()!==u?(e.substr(qn,2)===st?(n=st,qn+=2):(n=u,0===Fn&&Vn(at)),n!==u&&fu()!==u&&(s=Hn())!==u?(Qn=t,t=r=ot(r,s)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=qn,(r=Jn())!==u&&fu()!==u?(63===e.charCodeAt(qn)?(n=it,qn++):(n=u,0===Fn&&Vn(ct)),n!==u&&fu()!==u&&(s=Hn())!==u&&fu()!==u?(58===e.charCodeAt(qn)?(a=B,qn++):(a=u,0===Fn&&Vn($)),a!==u&&fu()!==u&&(o=Hn())!==u?(Qn=t,t=r=lt(r,s,o)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Jn())),Ln[i]={nextPos:qn,result:t},t)}function Jn(){var t,r,n,s,a,o=38*qn+10,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Kn())!==u&&fu()!==u?(n=qn,e.substr(qn,2)===ft?(s=ft,qn+=2):(s=u,0===Fn&&Vn(ht)),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=Jn())!==u?(Qn=t,t=r=At(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Kn()),Ln[o]={nextPos:qn,result:t},t)}function Kn(){var t,r,n,s,a,o=38*qn+11,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Wn())!==u&&fu()!==u?(n=qn,e.substr(qn,2)===dt?(s=dt,qn+=2):(s=u,0===Fn&&Vn(pt)),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=Kn())!==u?(Qn=t,t=r=At(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Wn()),Ln[o]={nextPos:qn,result:t},t)}function Wn(){var t,r,n,s,a,o=38*qn+12,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Xn())!==u&&fu()!==u?(n=qn,124===e.charCodeAt(qn)?(s=xt,qn++):(s=u,0===Fn&&Vn(bt)),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=Wn())!==u?(Qn=t,t=r=gt(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Xn()),Ln[o]={nextPos:qn,result:t},t)}function Xn(){var t,r,n,s,a,o=38*qn+13,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=Yn())!==u&&fu()!==u?(n=qn,94===e.charCodeAt(qn)?(s=vt,qn++):(s=u,0===Fn&&Vn(Pt)),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=Xn())!==u?(Qn=t,t=r=gt(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Yn()),Ln[o]={nextPos:qn,result:t},t)}function Yn(){var t,r,n,s,a,o=38*qn+14,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=tu())!==u&&fu()!==u?(n=qn,38===e.charCodeAt(qn)?(s=Ct,qn++):(s=u,0===Fn&&Vn(yt)),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=Yn())!==u?(Qn=t,t=r=gt(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=tu()),Ln[o]={nextPos:qn,result:t},t)}function tu(){var t,r,n,s,a,o=38*qn+15,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=eu())!==u&&fu()!==u?(n=qn,e.substr(qn,2)===mt?(s=mt,qn+=2):(s=u,0===Fn&&Vn(_t)),s===u&&(e.substr(qn,2)===wt?(s=wt,qn+=2):(s=u,0===Fn&&Vn(St)),s===u&&(e.substr(qn,2)===qt?(s=qt,qn+=2):(s=u,0===Fn&&Vn(Qt)),s===u&&(e.substr(qn,2)===Et?(s=Et,qn+=2):(s=u,0===Fn&&Vn(Rt)),s===u&&(60===e.charCodeAt(qn)?(s=Tt,qn++):(s=u,0===Fn&&Vn(Ft)),s===u&&(62===e.charCodeAt(qn)?(s=Lt,qn++):(s=u,0===Fn&&Vn(kt)),s===u&&(e.substr(qn,2)===Nt?(s=Nt,qn+=2):(s=u,0===Fn&&Vn(jt)),s===u&&(e.substr(qn,2)===Mt?(s=Mt,qn+=2):(s=u,0===Fn&&Vn(It))))))))),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=tu())!==u?(Qn=t,t=r=Ut(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=eu()),Ln[o]={nextPos:qn,result:t},t)}function eu(){var t,r,n,s,a,o=38*qn+16,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=ru())!==u&&fu()!==u?(n=qn,e.substr(qn,2)===Vt?(s=Vt,qn+=2):(s=u,0===Fn&&Vn(zt)),s===u&&(e.substr(qn,2)===Dt?(s=Dt,qn+=2):(s=u,0===Fn&&Vn(Ot))),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=eu())!==u?(Qn=t,t=r=gt(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=ru()),Ln[o]={nextPos:qn,result:t},t)}function ru(){var t,r,n,s,a,o=38*qn+17,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=nu())!==u&&fu()!==u?(n=qn,43===e.charCodeAt(qn)?(s=Zt,qn++):(s=u,0===Fn&&Vn(Bt)),s===u&&(45===e.charCodeAt(qn)?(s=$t,qn++):(s=u,0===Fn&&Vn(Gt))),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=ru())!==u?(Qn=t,t=r=Ht(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=nu()),Ln[o]={nextPos:qn,result:t},t)}function nu(){var t,r,n,s,a,o=38*qn+18,i=Ln[o];return i?(qn=i.nextPos,i.result):(t=qn,(r=uu())!==u&&fu()!==u?(n=qn,e.substr(qn,2)===Jt?(s=Jt,qn+=2):(s=u,0===Fn&&Vn(Kt)),s===u&&(42===e.charCodeAt(qn)?(s=W,qn++):(s=u,0===Fn&&Vn(X)),s===u&&(47===e.charCodeAt(qn)?(s=g,qn++):(s=u,0===Fn&&Vn(v)),s===u&&(37===e.charCodeAt(qn)?(s=Wt,qn++):(s=u,0===Fn&&Vn(Xt))))),(n=s!==u?e.substring(n,qn):s)!==u&&(s=fu())!==u&&(a=nu())!==u?(Qn=t,t=r=Ht(r,n,a)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=uu()),Ln[o]={nextPos:qn,result:t},t)}function uu(){var t,r,n,s=38*qn+19,a=Ln[s];return a?(qn=a.nextPos,a.result):(t=qn,r=qn,33===e.charCodeAt(qn)?(n=h,qn++):(n=u,0===Fn&&Vn(A)),n===u&&(126===e.charCodeAt(qn)?(n=Yt,qn++):(n=u,0===Fn&&Vn(te))),(r=n!==u?e.substring(r,qn):n)!==u&&(n=su())!==u?(Qn=t,t=r=ee(r,n)):(qn=t,t=u),t===u&&(t=su()),Ln[s]={nextPos:qn,result:t},t)}function su(){var t,r=38*qn+20,n=Ln[r];return n?(qn=n.nextPos,n.result):((t=function(){var t,r,n,s,a,o=38*qn+21,l=Ln[o];return l?(qn=l.nextPos,l.result):(t=qn,(r=au())!==u&&fu()!==u?(40===e.charCodeAt(qn)?(n=re,qn++):(n=u,0===Fn&&Vn(ne)),n!==u&&fu()!==u?((s=function(){var t,r,n,s,a,o,l,f,h=38*qn+22,A=Ln[h];if(A)return qn=A.nextPos,A.result;if(t=qn,(r=Hn())!==u){for(n=[],s=qn,(a=fu())!==u?(44===e.charCodeAt(qn)?(o=i,qn++):(o=u,0===Fn&&Vn(c)),o!==u&&(l=fu())!==u&&(f=Hn())!==u?s=a=[a,o,l,f]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,(a=fu())!==u?(44===e.charCodeAt(qn)?(o=i,qn++):(o=u,0===Fn&&Vn(c)),o!==u&&(l=fu())!==u&&(f=Hn())!==u?s=a=[a,o,l,f]:(qn=s,s=u)):(qn=s,s=u);n!==u?(Qn=t,r=oe(r,n),t=r):(qn=t,t=u)}else qn=t,t=u;return Ln[h]={nextPos:qn,result:t},t}())===u&&(s=null),s!==u&&fu()!==u?(41===e.charCodeAt(qn)?(a=ue,qn++):(a=u,0===Fn&&Vn(se)),a!==u?(Qn=t,r=ae(r,s),t=r):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[o]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,r,n,s=38*qn+23,a=Ln[s];return a?(qn=a.nextPos,a.result):(Fn++,t=qn,64===e.charCodeAt(qn)?(r=ce,qn++):(r=u,0===Fn&&Vn(le)),r!==u&&(n=au())!==u?(Qn=t,r=fe(n),t=r):(qn=t,t=u),t===u&&(t=qn,64===e.charCodeAt(qn)?(r=ce,qn++):(r=u,0===Fn&&Vn(le)),r!==u&&(n=ou())!==u?(Qn=t,r=he(n),t=r):(qn=t,t=u)),Fn--,t===u&&(r=u,0===Fn&&Vn(ie)),Ln[s]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,r,n,s,a=38*qn+24,o=Ln[a];return o?(qn=o.nextPos,o.result):(Fn++,t=qn,123===e.charCodeAt(qn)?(r=de,qn++):(r=u,0===Fn&&Vn(pe)),r!==u&&fu()!==u&&(n=au())!==u&&fu()!==u?(125===e.charCodeAt(qn)?(s=xe,qn++):(s=u,0===Fn&&Vn(be)),s!==u?(Qn=t,r=ge(n),t=r):(qn=t,t=u)):(qn=t,t=u),Fn--,t===u&&(r=u,0===Fn&&Vn(Ae)),Ln[a]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,r=38*qn+25,n=Ln[r];return n?(qn=n.nextPos,n.result):((t=ou())===u&&(t=function(){var t,r,n,s,a,o=38*qn+31,i=Ln[o];if(i)return qn=i.nextPos,i.result;if(Fn++,t=qn,96===e.charCodeAt(qn)?(r=yr,qn++):(r=u,0===Fn&&Vn(mr)),r!==u){for(n=qn,s=[],e.substr(qn,2)===_r?(a=_r,qn+=2):(a=u,0===Fn&&Vn(wr)),a===u&&(Sr.test(e.charAt(qn))?(a=e.charAt(qn),qn++):(a=u,0===Fn&&Vn(qr)));a!==u;)s.push(a),e.substr(qn,2)===_r?(a=_r,qn+=2):(a=u,0===Fn&&Vn(wr)),a===u&&(Sr.test(e.charAt(qn))?(a=e.charAt(qn),qn++):(a=u,0===Fn&&Vn(qr)));(n=s!==u?e.substring(n,qn):s)!==u?(96===e.charCodeAt(qn)?(s=yr,qn++):(s=u,0===Fn&&Vn(mr)),s!==u?(Qn=t,r=Qr(n),t=r):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(r=u,0===Fn&&Vn(Cr)),Ln[o]={nextPos:qn,result:t},t}())===u&&(t=function(){var t,r,n,s,a,o,i,c,l,f,h,A,d=38*qn+32,p=Ln[d];if(p)return qn=p.nextPos,p.result;if(Fn++,t=qn,r=qn,Rr.test(e.charAt(qn))?(n=e.charAt(qn),qn++):(n=u,0===Fn&&Vn(Tr)),n===u&&(n=null),(r=n!==u?e.substring(r,qn):n)!==u)if(e.substr(qn,2)===Fr?(n=Fr,qn+=2):(n=u,0===Fn&&Vn(Lr)),n!==u){if(s=qn,a=[],kr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Nr)),o!==u)for(;o!==u;)a.push(o),kr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Nr));else a=u;(s=a!==u?e.substring(s,qn):a)!==u?(Qn=t,r=jr(r,s),t=r):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,r=qn,Rr.test(e.charAt(qn))?(n=e.charAt(qn),qn++):(n=u,0===Fn&&Vn(Tr)),n===u&&(n=null),(r=n!==u?e.substring(r,qn):n)!==u)if(e.substr(qn,2)===Mr?(n=Mr,qn+=2):(n=u,0===Fn&&Vn(Ir)),n!==u){if(s=qn,a=[],Ur.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Vr)),o!==u)for(;o!==u;)a.push(o),Ur.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Vr));else a=u;(s=a!==u?e.substring(s,qn):a)!==u?(Qn=t,r=zr(r,s),t=r):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,r=qn,Rr.test(e.charAt(qn))?(n=e.charAt(qn),qn++):(n=u,0===Fn&&Vn(Tr)),n===u&&(n=null),(r=n!==u?e.substring(r,qn):n)!==u)if(e.substr(qn,2)===Dr?(n=Dr,qn+=2):(n=u,0===Fn&&Vn(Or)),n!==u){if(s=qn,a=[],hr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Ar)),o!==u)for(;o!==u;)a.push(o),hr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Ar));else a=u;(s=a!==u?e.substring(s,qn):a)!==u?(Qn=t,r=Zr(r,s),t=r):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,r=qn,n=qn,Rr.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Tr)),s===u&&(s=null),s!==u){for(a=[],Br.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn($r));o!==u;)a.push(o),Br.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn($r));if(a!==u)if(46===e.charCodeAt(qn)?(o=Gr,qn++):(o=u,0===Fn&&Vn(Hr)),o!==u){if(i=[],Br.test(e.charAt(qn))?(c=e.charAt(qn),qn++):(c=u,0===Fn&&Vn($r)),c!==u)for(;c!==u;)i.push(c),Br.test(e.charAt(qn))?(c=e.charAt(qn),qn++):(c=u,0===Fn&&Vn($r));else i=u;if(i!==u){if(c=qn,Jr.test(e.charAt(qn))?(l=e.charAt(qn),qn++):(l=u,0===Fn&&Vn(Kr)),l!==u)if(Rr.test(e.charAt(qn))?(f=e.charAt(qn),qn++):(f=u,0===Fn&&Vn(Tr)),f===u&&(f=null),f!==u){if(h=[],Br.test(e.charAt(qn))?(A=e.charAt(qn),qn++):(A=u,0===Fn&&Vn($r)),A!==u)for(;A!==u;)h.push(A),Br.test(e.charAt(qn))?(A=e.charAt(qn),qn++):(A=u,0===Fn&&Vn($r));else h=u;h!==u?c=l=[l,f,h]:(qn=c,c=u)}else qn=c,c=u;else qn=c,c=u;c===u&&(c=null),c!==u?n=s=[s,a,o,i,c]:(qn=n,n=u)}else qn=n,n=u}else qn=n,n=u;else qn=n,n=u}else qn=n,n=u;if((r=n!==u?e.substring(r,qn):n)!==u&&(Qn=t,r=Wr(r)),(t=r)===u){if(t=qn,r=qn,n=qn,Rr.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Tr)),s===u&&(s=null),s!==u){if(a=[],Br.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn($r)),o!==u)for(;o!==u;)a.push(o),Br.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn($r));else a=u;a!==u?n=s=[s,a]:(qn=n,n=u)}else qn=n,n=u;(r=n!==u?e.substring(r,qn):n)!==u&&(Qn=t,r=Xr(r)),t=r}}}}return Fn--,t===u&&(r=u,0===Fn&&Vn(Er)),Ln[d]={nextPos:qn,result:t},t}())===u&&(t=lu()),Ln[r]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,r,n,s,a=38*qn+26,o=Ln[a];return o?(qn=o.nextPos,o.result):(t=qn,40===e.charCodeAt(qn)?(r=re,qn++):(r=u,0===Fn&&Vn(ne)),r!==u&&fu()!==u&&(n=Hn())!==u&&fu()!==u?(41===e.charCodeAt(qn)?(s=ue,qn++):(s=u,0===Fn&&Vn(se)),s!==u?(Qn=t,r=ve(n),t=r):(qn=t,t=u)):(qn=t,t=u),Ln[a]={nextPos:qn,result:t},t)}())===u&&(t=On()),Ln[r]={nextPos:qn,result:t},t)}function au(){var t,r,n,s,a,o,i,c=38*qn+27,l=Ln[c];if(l)return qn=l.nextPos,l.result;if(Fn++,t=qn,r=qn,n=qn,s=qn,Fn++,a=lu(),Fn--,a===u?s=void 0:(qn=s,s=u),s!==u)if(Ce.test(e.charAt(qn))?(a=e.charAt(qn),qn++):(a=u,0===Fn&&Vn(ye)),a!==u){for(o=[],me.test(e.charAt(qn))?(i=e.charAt(qn),qn++):(i=u,0===Fn&&Vn(_e));i!==u;)o.push(i),me.test(e.charAt(qn))?(i=e.charAt(qn),qn++):(i=u,0===Fn&&Vn(_e));o!==u?n=s=[s,a,o]:(qn=n,n=u)}else qn=n,n=u;else qn=n,n=u;return(r=n!==u?e.substring(r,qn):n)!==u&&(Qn=t,r=we(r)),Fn--,(t=r)===u&&(r=u,0===Fn&&Vn(Pe)),Ln[c]={nextPos:qn,result:t},t}function ou(){var t,r,n,s,a=38*qn+28,o=Ln[a];if(o)return qn=o.nextPos,o.result;if(Fn++,t=qn,34===e.charCodeAt(qn)?(r=qe,qn++):(r=u,0===Fn&&Vn(Qe)),r!==u){for(n=[],(s=iu())===u&&(Ee.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Re)));s!==u;)n.push(s),(s=iu())===u&&(Ee.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Re)));n!==u?(34===e.charCodeAt(qn)?(s=qe,qn++):(s=u,0===Fn&&Vn(Qe)),s!==u?(Qn=t,t=r=Te(n)):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;if(t===u)if(t=qn,39===e.charCodeAt(qn)?(r=Fe,qn++):(r=u,0===Fn&&Vn(Le)),r!==u){for(n=[],(s=cu())===u&&(ke.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Ne)));s!==u;)n.push(s),(s=cu())===u&&(ke.test(e.charAt(qn))?(s=e.charAt(qn),qn++):(s=u,0===Fn&&Vn(Ne)));n!==u?(39===e.charCodeAt(qn)?(s=Fe,qn++):(s=u,0===Fn&&Vn(Le)),s!==u?(Qn=t,t=r=Te(n)):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(r=u,0===Fn&&Vn(Se)),Ln[a]={nextPos:qn,result:t},t}function iu(){var t,r,n,s,a,o,i,c,l=38*qn+29,f=Ln[l];return f?(qn=f.nextPos,f.result):(Fn++,t=qn,e.substr(qn,2)===Me?(r=Me,qn+=2):(r=u,0===Fn&&Vn(Ie)),r!==u&&(Qn=t,r=Ue()),(t=r)===u&&(t=qn,e.substr(qn,2)===Ve?(r=Ve,qn+=2):(r=u,0===Fn&&Vn(ze)),r!==u&&(Qn=t,r=De()),(t=r)===u&&(t=qn,e.substr(qn,2)===Oe?(r=Oe,qn+=2):(r=u,0===Fn&&Vn(Ze)),r!==u&&(Qn=t,r=Be()),(t=r)===u&&(t=qn,e.substr(qn,2)===$e?(r=$e,qn+=2):(r=u,0===Fn&&Vn(Ge)),r!==u&&(Qn=t,r=He()),(t=r)===u&&(t=qn,e.substr(qn,2)===Je?(r=Je,qn+=2):(r=u,0===Fn&&Vn(Ke)),r!==u&&(Qn=t,r=We()),(t=r)===u&&(t=qn,e.substr(qn,2)===Xe?(r=Xe,qn+=2):(r=u,0===Fn&&Vn(Ye)),r!==u&&(Qn=t,r=tr()),(t=r)===u&&(t=qn,e.substr(qn,2)===er?(r=er,qn+=2):(r=u,0===Fn&&Vn(rr)),r!==u&&(Qn=t,r=nr()),(t=r)===u&&(t=qn,e.substr(qn,2)===ur?(r=ur,qn+=2):(r=u,0===Fn&&Vn(sr)),r!==u&&(Qn=t,r=ar()),(t=r)===u&&(t=qn,e.substr(qn,2)===or?(r=or,qn+=2):(r=u,0===Fn&&Vn(ir)),r!==u&&(Qn=t,r=cr()),(t=r)===u&&(t=qn,e.substr(qn,2)===lr?(r=lr,qn+=2):(r=u,0===Fn&&Vn(fr)),r!==u?(n=qn,s=qn,hr.test(e.charAt(qn))?(a=e.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ar)),a!==u?(hr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Ar)),o!==u?s=a=[a,o]:(qn=s,s=u)):(qn=s,s=u),(n=s!==u?e.substring(n,qn):s)!==u?(Qn=t,t=r=dr(n)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=qn,e.substr(qn,2)===pr?(r=pr,qn+=2):(r=u,0===Fn&&Vn(xr)),r!==u?(n=qn,s=qn,hr.test(e.charAt(qn))?(a=e.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ar)),a!==u?(hr.test(e.charAt(qn))?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(Ar)),o!==u?(hr.test(e.charAt(qn))?(i=e.charAt(qn),qn++):(i=u,0===Fn&&Vn(Ar)),i!==u?(hr.test(e.charAt(qn))?(c=e.charAt(qn),qn++):(c=u,0===Fn&&Vn(Ar)),c!==u?s=a=[a,o,i,c]:(qn=s,s=u)):(qn=s,s=u)):(qn=s,s=u)):(qn=s,s=u),(n=s!==u?e.substring(n,qn):s)!==u?(Qn=t,t=r=dr(n)):(qn=t,t=u)):(qn=t,t=u))))))))))),Fn--,t===u&&(r=u,0===Fn&&Vn(je)),Ln[l]={nextPos:qn,result:t},t)}function cu(){var t,r,n=38*qn+30,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,e.substr(qn,2)===gr?(r=gr,qn+=2):(r=u,0===Fn&&Vn(vr)),r!==u&&(Qn=t,r=Pr()),Fn--,(t=r)===u&&(r=u,0===Fn&&Vn(br)),Ln[n]={nextPos:qn,result:t},t)}function lu(){var t,r,n=38*qn+33,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,e.substr(qn,4)===tn?(r=tn,qn+=4):(r=u,0===Fn&&Vn(en)),r!==u&&(Qn=t,r=rn()),(t=r)===u&&(t=qn,e.substr(qn,5)===nn?(r=nn,qn+=5):(r=u,0===Fn&&Vn(un)),r!==u&&(Qn=t,r=sn()),(t=r)===u&&(t=qn,e.substr(qn,4)===an?(r=an,qn+=4):(r=u,0===Fn&&Vn(on)),r!==u&&(Qn=t,r=cn()),(t=r)===u&&(t=qn,e.substr(qn,3)===ln?(r=ln,qn+=3):(r=u,0===Fn&&Vn(fn)),r!==u&&(Qn=t,r=hn()),(t=r)===u&&(t=qn,e.substr(qn,9)===An?(r=An,qn+=9):(r=u,0===Fn&&Vn(dn)),r!==u&&(Qn=t,r=pn()),t=r)))),Fn--,t===u&&(r=u,0===Fn&&Vn(Yr)),Ln[n]={nextPos:qn,result:t},t)}function fu(){var t,e,r=38*qn+34,n=Ln[r];if(n)return qn=n.nextPos,n.result;for(Fn++,t=[],(e=hu())===u&&(e=Au());e!==u;)t.push(e),(e=hu())===u&&(e=Au());return Fn--,t===u&&(e=u,0===Fn&&Vn(xn)),Ln[r]={nextPos:qn,result:t},t}function hu(){var t,r,n,s,a,o,i=38*qn+35,c=Ln[i];if(c)return qn=c.nextPos,c.result;if(Fn++,t=qn,e.substr(qn,2)===gn?(r=gn,qn+=2):(r=u,0===Fn&&Vn(vn)),r!==u){for(n=[],s=qn,a=qn,Fn++,e.substr(qn,2)===Pn?(o=Pn,qn+=2):(o=u,0===Fn&&Vn(Cn)),Fn--,o===u?a=void 0:(qn=a,a=u),a!==u?(e.length>qn?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(yn)),o!==u?s=a=[a,o]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,a=qn,Fn++,e.substr(qn,2)===Pn?(o=Pn,qn+=2):(o=u,0===Fn&&Vn(Cn)),Fn--,o===u?a=void 0:(qn=a,a=u),a!==u?(e.length>qn?(o=e.charAt(qn),qn++):(o=u,0===Fn&&Vn(yn)),o!==u?s=a=[a,o]:(qn=s,s=u)):(qn=s,s=u);n!==u?(e.substr(qn,2)===Pn?(s=Pn,qn+=2):(s=u,0===Fn&&Vn(Cn)),s!==u?t=r=[r,n,s]:(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(r=u,0===Fn&&Vn(bn)),Ln[i]={nextPos:qn,result:t},t}function Au(){var t,r,n=38*qn+36,s=Ln[n];if(s)return qn=s.nextPos,s.result;if(Fn++,t=[],_n.test(e.charAt(qn))?(r=e.charAt(qn),qn++):(r=u,0===Fn&&Vn(wn)),r!==u)for(;r!==u;)t.push(r),_n.test(e.charAt(qn))?(r=e.charAt(qn),qn++):(r=u,0===Fn&&Vn(wn));else t=u;return Fn--,t===u&&(r=u,0===Fn&&Vn(mn)),Ln[n]={nextPos:qn,result:t},t}var du=r.util.makeUnroll(kn,r),pu=r.util.makeAST(kn,r);if((n=a())!==u&&qn===e.length)return n;throw n!==u&&qn<e.length&&Vn({type:"end"}),zn(Tn,Rn<e.length?e.charAt(Rn):null,Rn<e.length?Un(Rn,Rn+1):Un(Rn,Rn))}}}(),ASTQQuery=function(){function t(e){_classCallCheck(this,t),this.asty=new _asty.default,this.ast=null,e&&this.compile(e)}return _createClass(t,[{key:"compile",value:function(t,e){var r=this;e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=_pegjsUtil.default.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,e,n,u){return r.asty.create.apply(r.asty,u).pos(t,e,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+_pegjsUtil.default.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){return this.ast.dump()}},{key:"execute",value:function(t,e,r,n,u){return u&&console.log("ASTQ: execute: +-------------------------------------------------------------------------------------------------------"),new _astqQueryExec.default(e,r,n,u).execQuery(this.ast,t)}}]),t}();exports.default=ASTQQuery;
},{"./astq-query-exec.js":15,"asty":1,"pegjs-util":3}],18:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQUtil=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function(e,t){var r=t<0?-t:t;if(e.length>r)e=e.substr(0,r);else{var n=Array(r+1-e.length).join(" ");e=t<0?e+n:n+e}return e}},{key:"truthy",value:function(e){var t;switch(_typeof(e)){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if(_typeof(e)!==t)try{switch(t){case"boolean":"object"===_typeof(e)&&e instanceof Array?e=0!==e.length:"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"object"===_typeof(e)&&e instanceof Array?e=e.length:"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"===_typeof(e)&&e instanceof RegExp||(e=new RegExp(e))}}catch(e){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();exports.default=ASTQUtil;
},{}],19:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var version={major:2,minor:7,micro:8,date:20220525},_default=version;exports.default=_default;
},{}],20:[function(_dereq_,module,exports){
"use strict";var _cacheLru=_interopRequireDefault(_dereq_("cache-lru")),_astqAdapter=_interopRequireDefault(_dereq_("./astq-adapter.js")),_astqAdapterXmldom=_interopRequireDefault(_dereq_("./astq-adapter-xmldom.js")),_astqAdapterParse=_interopRequireDefault(_dereq_("./astq-adapter-parse5.js")),_astqAdapterMozast=_interopRequireDefault(_dereq_("./astq-adapter-mozast.js")),_astqAdapterGraphql=_interopRequireDefault(_dereq_("./astq-adapter-graphql.js")),_astqAdapterJson=_interopRequireDefault(_dereq_("./astq-adapter-json.js")),_astqAdapterCheerio=_interopRequireDefault(_dereq_("./astq-adapter-cheerio.js")),_astqAdapterUnist=_interopRequireDefault(_dereq_("./astq-adapter-unist.js")),_astqAdapterAsty=_interopRequireDefault(_dereq_("./astq-adapter-asty.js")),_astqFuncs=_interopRequireDefault(_dereq_("./astq-funcs.js")),_astqFuncsStd=_interopRequireDefault(_dereq_("./astq-funcs-std.js")),_astqQuery=_interopRequireDefault(_dereq_("./astq-query.js")),_astqVersion=_interopRequireDefault(_dereq_("./astq-version.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}var ASTQ=function(){function e(){for(var t in _classCallCheck(this,e),this._adapter=(new _astqAdapter.default).register(_astqAdapterXmldom.default,!1).register(_astqAdapterParse.default,!1).register(_astqAdapterMozast.default,!1).register(_astqAdapterGraphql.default,!1).register(_astqAdapterJson.default,!1).register(_astqAdapterCheerio.default,!1).register(_astqAdapterUnist.default,!1).register(_astqAdapterAsty.default,!1),this._funcs=new _astqFuncs.default,_astqFuncsStd.default)this.func(t,_astqFuncsStd.default[t]);this._cache=new _cacheLru.default}return _createClass(e,[{key:"version",value:function(){return _astqVersion.default}},{key:"adapter",value:function(e){var t=this,r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(arguments.length<1||arguments.length>2)throw new Error("ASTQ#adapter: invalid number of arguments");if(this._adapter.unregister(),"object"===_typeof(e)&&e instanceof Array||(e=[e]),e.length>1&&r)throw new Error("ASTQ#adapter: you can force just a single adapter to not taste the AST node");return e.forEach(function(e){if("string"==typeof e)if("mozast"===e)e=_astqAdapterMozast.default;else if("graphql"===e)e=_astqAdapterGraphql.default;else if("xmldom"===e)e=_astqAdapterXmldom.default;else if("parse5"===e)e=_astqAdapterParse.default;else if("json"===e)e=_astqAdapterJson.default;else if("cheerio"===e)e=_astqAdapterCheerio.default;else if("unist"===e)e=_astqAdapterUnist.default;else{if("asty"!==e)throw new Error("ASTQ#adapter: unknown built-in adapter");e=_astqAdapterAsty.default}t._adapter.register(e,r)}),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&((r=new _astqQuery.default).compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===a&&(a=!1);var s=this._adapter.select(e);if(void 0===s)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,s,r,this._funcs,a)}},{key:"query",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===a&&(a=!1),this.execute(e,this.compile(t,a),r,a)}}]),e}();module.exports=ASTQ;
},{"./astq-adapter-asty.js":4,"./astq-adapter-cheerio.js":5,"./astq-adapter-graphql.js":6,"./astq-adapter-json.js":7,"./astq-adapter-mozast.js":8,"./astq-adapter-parse5.js":9,"./astq-adapter-unist.js":10,"./astq-adapter-xmldom.js":11,"./astq-adapter.js":12,"./astq-funcs-std.js":13,"./astq-funcs.js":14,"./astq-query.js":17,"./astq-version.js":19,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])(20)
});
